From a59e8a7f6fed2accd1034eebf16545ef78c3ea1b Mon Sep 17 00:00:00 2001
From: Patrick Zhang <patrick@os.amperecomputing.com>
Date: Tue, 4 Feb 2020 21:27:10 +0800
Subject: [PATCH] 8238380: java.base/unix/native/libjava/childproc.c "multiple
 definition" link errors with GCC10

Reviewed-by: stuefe, clanger, rriggs
---
 src/java.base/unix/native/libjava/childproc.c | 3 ++-
 src/java.base/unix/native/libjava/childproc.h | 4 ++--
 2 files changed, 4 insertions(+), 3 deletions(-)

diff --git a/src/java.base/unix/native/libjava/childproc.c b/src/java.base/unix/native/libjava/childproc.c
index 811aaeac5f..1044b8ee22 100644
--- a/src/java.base/unix/native/libjava/childproc.c
+++ b/src/java.base/unix/native/libjava/childproc.c
@@ -34,6 +34,7 @@
 
 #include "childproc.h"
 
+const char * const *parentPathv;
 
 ssize_t
 restartableWrite(int fd, const void *buf, size_t count)
diff --git a/src/java.base/unix/native/libjava/childproc.h b/src/java.base/unix/native/libjava/childproc.h
index 0911509302..2190dd1792 100644
--- a/src/java.base/unix/native/libjava/childproc.h
+++ b/src/java.base/unix/native/libjava/childproc.h
@@ -126,7 +126,7 @@ typedef struct _SpawnInfo {
  * The cached and split version of the JDK's effective PATH.
  * (We don't support putenv("PATH=...") in native code)
  */
-const char * const *parentPathv;
+extern const char * const *parentPathv;
 
 ssize_t restartableWrite(int fd, const void *buf, size_t count);
 int restartableDup2(int fd_from, int fd_to);
-- 
2.25.1

From 1d42f083c1b64e68eec19471c3f7045c6cbc841f Mon Sep 17 00:00:00 2001
From: Patrick Zhang <qpzhang@openjdk.org>
Date: Wed, 5 Feb 2020 17:14:15 +0800
Subject: [PATCH] 8238386: (sctp) jdk.sctp/unix/native/libsctp/SctpNet.c
 "multiple definition" link errors with GCC10

Fixed libsctp link errors caused by GCC10 default -fno-common

Reviewed-by: chegar
---
 src/jdk.sctp/unix/native/libsctp/Sctp.h    | 14 +++++++-------
 src/jdk.sctp/unix/native/libsctp/SctpNet.c |  9 ++++++++-
 2 files changed, 15 insertions(+), 8 deletions(-)

diff --git a/src/jdk.sctp/unix/native/libsctp/Sctp.h b/src/jdk.sctp/unix/native/libsctp/Sctp.h
index cc1367f781..d6810d61be 100644
--- a/src/jdk.sctp/unix/native/libsctp/Sctp.h
+++ b/src/jdk.sctp/unix/native/libsctp/Sctp.h
@@ -322,12 +322,12 @@ typedef int sctp_peeloff_func(int sock, sctp_assoc_t id);
 
 #endif /* __linux__ */
 
-sctp_getladdrs_func* nio_sctp_getladdrs;
-sctp_freeladdrs_func* nio_sctp_freeladdrs;
-sctp_getpaddrs_func* nio_sctp_getpaddrs;
-sctp_freepaddrs_func* nio_sctp_freepaddrs;
-sctp_bindx_func* nio_sctp_bindx;
-sctp_peeloff_func* nio_sctp_peeloff;
+extern sctp_getladdrs_func* nio_sctp_getladdrs;
+extern sctp_freeladdrs_func* nio_sctp_freeladdrs;
+extern sctp_getpaddrs_func* nio_sctp_getpaddrs;
+extern sctp_freepaddrs_func* nio_sctp_freepaddrs;
+extern sctp_bindx_func* nio_sctp_bindx;
+extern sctp_peeloff_func* nio_sctp_peeloff;
 
 jboolean loadSocketExtensionFuncs(JNIEnv* env);
 
diff --git a/src/jdk.sctp/unix/native/libsctp/SctpNet.c b/src/jdk.sctp/unix/native/libsctp/SctpNet.c
index d40c15aa35..b8d0ad8ab2 100644
--- a/src/jdk.sctp/unix/native/libsctp/SctpNet.c
+++ b/src/jdk.sctp/unix/native/libsctp/SctpNet.c
@@ -43,6 +43,13 @@ static jmethodID isaCtrID = 0;
 static const char* nativeSctpLib = "libsctp.so.1";
 static jboolean funcsLoaded = JNI_FALSE;
 
+sctp_getladdrs_func* nio_sctp_getladdrs;
+sctp_freeladdrs_func* nio_sctp_freeladdrs;
+sctp_getpaddrs_func* nio_sctp_getpaddrs;
+sctp_freepaddrs_func* nio_sctp_freepaddrs;
+sctp_bindx_func* nio_sctp_bindx;
+sctp_peeloff_func* nio_sctp_peeloff;
+
 JNIEXPORT jint JNICALL DEF_JNI_OnLoad
   (JavaVM *vm, void *reserved) {
     return JNI_VERSION_1_2;
-- 
2.25.1

From 03721247d8f3d6b2aefe2826a59c10fd1fad51cb Mon Sep 17 00:00:00 2001
From: Patrick Zhang <qpzhang@openjdk.org>
Date: Wed, 5 Feb 2020 20:31:09 +0800
Subject: [PATCH] 8238388: libj2gss/NativeFunc.o "multiple definition" link
 errors with GCC10

Fixed libj2gss link errors caused by GCC10 default -fno-common

Reviewed-by: weijun
---
 src/java.security.jgss/share/native/libj2gss/NativeFunc.c | 5 ++++-
 src/java.security.jgss/share/native/libj2gss/NativeFunc.h | 4 ++--
 2 files changed, 6 insertions(+), 3 deletions(-)

diff --git a/src/java.security.jgss/share/native/libj2gss/NativeFunc.c b/src/java.security.jgss/share/native/libj2gss/NativeFunc.c
index da7bc0445b..577b6ec5be 100644
--- a/src/java.security.jgss/share/native/libj2gss/NativeFunc.c
+++ b/src/java.security.jgss/share/native/libj2gss/NativeFunc.c
@@ -27,6 +27,9 @@
 #include <stdlib.h>
 #include "NativeFunc.h"
 
+/* global GSS function table */
+GSS_FUNCTION_TABLE_PTR ftab;
+
 /* standard GSS method names (ordering is from mapfile) */
 static const char RELEASE_NAME[]                = "gss_release_name";
 static const char IMPORT_NAME[]                 = "gss_import_name";
diff --git a/src/java.security.jgss/share/native/libj2gss/NativeFunc.h b/src/java.security.jgss/share/native/libj2gss/NativeFunc.h
index 82914387c2..d695120122 100644
--- a/src/java.security.jgss/share/native/libj2gss/NativeFunc.h
+++ b/src/java.security.jgss/share/native/libj2gss/NativeFunc.h
@@ -277,6 +277,6 @@ typedef struct GSS_FUNCTION_TABLE {
 typedef GSS_FUNCTION_TABLE *GSS_FUNCTION_TABLE_PTR;
 
 /* global GSS function table */
-GSS_FUNCTION_TABLE_PTR ftab;
+extern GSS_FUNCTION_TABLE_PTR ftab;
 
 #endif
-- 
2.25.1

